import crypto from "crypto";
import { parentPort, workerData } from "worker_threads";

const { salt, target } = workerData;

const saltBuffer = Buffer.from(salt);
const targetLen = target.length;
const targetBytes = Math.ceil(targetLen / 2);

let nonce = 0;

while (true) {
  const nonceStr = nonce.toString();

  const hash = crypto.createHash("sha256");

  hash.update(saltBuffer);
  hash.update(nonceStr);

  const hashBuffer = hash.digest();

  const hashPrefixHex = hashBuffer.toString("hex", 0, targetBytes);

  if (hashPrefixHex.startsWith(target)) {
    parentPort.postMessage({
      nonce: Number(nonce),
      salt,
      target,
    });
    break;
  }

  nonce++;
}
